%global kf5_version_min 5.98

%global synaptics 0
%global scim 0

Name:    plasma-desktop
Summary: Plasma Desktop shell
Version: 5.27.10
Release:    1%{?dist}

License: GPLv2+ and (GPLv2 or GPLv3)
URL:     https://invent.kde.org/plasma/%{name}

%global verdir %(echo %{version} | cut -d. -f1-3)
%global revision %(echo %{version} | cut -d. -f3)
%if %{revision} >= 50
%global majmin_ver %(echo %{version} | cut -d. -f1,2).50
%global stable unstable
%else
%global majmin_ver %(echo %{version} | cut -d. -f1,2)
%global stable stable
%endif
Source0: http://download.kde.org/%{stable}/plasma/%{verdir}/%{name}-%{version}.tar.xz


Patch100: plasma-desktop-5.8-default_favorites.patch

Patch202: plasma-desktop-python-shebang.patch

Source200: synaptics-properties.h

%global __provides_exclude_from ^(%{_kf5_qmldir}/.*\\.so|%{_kf5_qtplugindir}/.*\\.so)$

BuildRequires:  pkgconfig(libusb)
BuildRequires:  fontconfig-devel
BuildRequires:  libX11-devel
BuildRequires:  libxkbfile-devel
BuildRequires:  libxcb-devel
BuildRequires:  xcb-util-keysyms-devel
BuildRequires:  xcb-util-image-devel
BuildRequires:  xcb-util-renderutil-devel
BuildRequires:  xcb-util-devel
BuildRequires:  libxkbcommon-devel
BuildRequires:  pkgconfig(xkeyboard-config)

BuildRequires:  qt5-qtbase-devel >= 5.9
BuildRequires:  qt5-qtbase-private-devel
BuildRequires:  qt5-qtx11extras-devel
BuildRequires:  qt5-qtsvg-devel
BuildRequires:  qt5-qtdeclarative-devel
BuildRequires:  qt5-qtwayland-devel
BuildRequires:  phonon-qt5-devel
BuildRequires:  wayland-protocols-devel

BuildRequires:  ibus-devel
%if 0%{?scim}
BuildRequires:  scim-devel
%endif

BuildRequires:  kf5-rpm-macros >= %{kf5_version_min}
BuildRequires:  extra-cmake-modules
BuildRequires:  kf5-plasma-devel >= %{kf5_version_min}
Requires:       kf5-plasma >= %{_kf5_version}
BuildRequires:  kf5-kdoctools-devel >= %{kf5_version_min}
BuildRequires:  kf5-ki18n-devel >= %{kf5_version_min}
BuildRequires:  kf5-kcmutils-devel >= %{kf5_version_min}
BuildRequires:  kf5-kglobalaccel-devel >= %{kf5_version_min}
BuildRequires:  kf5-knewstuff-devel >= %{kf5_version_min}
BuildRequires:  kf5-kdelibs4support-devel >= %{kf5_version_min}
BuildRequires:  kf5-knotifyconfig-devel >= %{kf5_version_min}
BuildRequires:  kf5-kdesu-devel >= %{kf5_version_min}
BuildRequires:  kf5-attica-devel >= %{kf5_version_min}
BuildRequires:  kf5-kwallet-devel >= %{kf5_version_min}
BuildRequires:  kf5-krunner-devel >= %{kf5_version_min}
BuildRequires:  kf5-baloo-devel >= %{kf5_version_min}
BuildRequires:  kf5-kdeclarative-devel >= %{kf5_version_min}
BuildRequires:  kf5-kpeople-devel >= %{kf5_version_min}
BuildRequires:  kf5-kded-devel >= %{kf5_version_min}

BuildRequires:  libksysguard-devel >= %{majmin_ver}
BuildRequires:  kscreenlocker-devel >= %{majmin_ver}
BuildRequires:  kwin-devel >= %{majmin_ver}
BuildRequires:  plasma-breeze >= %{majmin_ver}
BuildRequires:  plasma-workspace-devel >= %{majmin_ver}

BuildRequires:  cmake(AppStreamQt)
BuildRequires:  cmake(KAccounts) intltool
BuildRequires:  cmake(KUserFeedback)
BuildRequires:  PackageKit-Qt5-devel
BuildRequires:  kf5-kactivities-devel >= %{kf5_version_min}
BuildRequires:  kf5-kactivities-stats-devel >= %{kf5_version_min}
BuildRequires:  libcanberra-devel
BuildRequires:  boost-devel
BuildRequires:  pulseaudio-libs-devel

BuildRequires:  chrpath
BuildRequires:  desktop-file-utils

%ifnarch s390 s390x
Provides:       kcm_touchpad = %{version}-%{release}
BuildRequires:  xorg-x11-server-devel
Requires:       kf5-kded

BuildRequires:  pkgconfig(libudev)
Requires:       iso-codes

BuildRequires:  pkgconfig(xorg-evdev)
BuildRequires:  pkgconfig(xorg-libinput)
%if 0%{?synaptics}
BuildRequires:  pkgconfig(xorg-synaptics)
%endif
%endif

Requires:       accountsservice

Requires:       plasma-workspace >= %{majmin_ver}

Requires:       plasma-integration >= %{majmin_ver}

Requires:       plasma-systemsettings >= %{majmin_ver}
Requires:       kio-extras
Requires:       kwrited >= %{majmin_ver}

Requires:       kwin >= %{majmin_ver}

Requires:       kmenuedit >= %{majmin_ver}

BuildRequires:  kf5-kirigami2
Requires:       kf5-kirigami2
BuildRequires:  qqc2-desktop-style
Requires:       qqc2-desktop-style

Recommends: ibus

Provides:       plasmashell(desktop) = %{version}-%{release}
Provides:       plasmashell = %{version}-%{release}


Provides:       kactivities-workspace = %{version}-%{release}

Provides:       plasma-user-manager = %{version}-%{release}

Conflicts:      kdeplasma-addons < 5.6.0

Conflicts:      kde-l10n < 15.12.3-4

%description
%{summary}.

%package        kimpanel-scim
Summary:        SCIM backend for kimpanel
Requires:       %{name} = %{version}-%{release}
%description    kimpanel-scim
A backend for the kimpanel panel icon for input methods using the SCIM input
method framework.

%package        doc
Summary:        Documentation and user manuals for %{name}
Conflicts:      kcm_colors < 1:4.11.16-10
Conflicts:      kde-runtime-docs < 17.08.3-6
BuildArch: noarch
%description    doc
%{summary}.


%prep
%setup -q


%patch202 -p1

%if ! 0%{?synaptics}
install -pD %{SOURCE200} 3rdparty/xorg/synaptics-properties.h
%endif

%patch100 -p1

sed -i.breeze_ver \
  -e "s|find_package(Breeze \${PROJECT_VERSION} |find_package(Breeze %{majmin_ver} |g" \
  -e "s|find_package(LibKWorkspace \${PROJECT_VERSION} |find_package(LibKWorkspace %{majmin_ver} |g" \
  -e "s|find_package(LibColorCorrect \${PROJECT_VERSION} |find_package(LibColorCorrect %{majmin_ver} |g" \
  -e "s|find_package(LibNotificationManager \${PROJECT_VERSION} |find_package(LibNotificationManager %{majmin_ver} |g" \
  -e "s|find_package(LibTaskManager \${PROJECT_VERSION} |find_package(LibTaskManager %{majmin_ver} |g" \
  CMakeLists.txt


%build
%ifarch s390 %{arm}
%global optflags %(echo %{optflags} | sed 's/-g /-g1 /')
%endif

%{cmake_kf5} \
  %{?!synaptics:-DSynaptics_INCLUDE_DIRS:PATH="$(pwd)/../3rdparty/xorg"}
%cmake_build


%install
%cmake_install

%find_lang %{name} --with-html --all-name

grep "%{_kf5_docdir}" %{name}.lang > %{name}-doc.lang
cat  %{name}.lang %{name}-doc.lang | sort | uniq -u > plasmadesktop5.lang

rm -fv %{buildroot}%{_libdir}/libkfontinst{,ui}.so

rm -rfv %{buildroot}%{_datadir}/kdm/pics/users/
rm -rfv %{buildroot}%{_datadir}/locale/*/LC_SCRIPTS/kfontinst/


%check
desktop-file-validate %{buildroot}/%{_datadir}/applications/org.kde.knetattach.desktop


%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files -f plasmadesktop5.lang
%license LICENSES
%{_bindir}/kaccess
%{_bindir}/knetattach
%{_bindir}/solid-action-desktop-gen
%{_bindir}/plasma-emojier
%{_bindir}/tastenbrett
%{_bindir}/krunner-plugininstaller
%{_kf5_libexecdir}/kauth/kcmdatetimehelper
%{_libexecdir}/kimpanel-ibus-panel
%{_libexecdir}/kimpanel-ibus-panel-launcher
%{_kf5_qmldir}/org/kde/plasma/private
%{_kf5_qtplugindir}/*.so
%{_kf5_qtplugindir}/plasma/kcms/desktop/kcm_krunnersettings.so
%{_kf5_qtplugindir}/plasma/kcms/systemsettings/*.so
%{_kf5_qtplugindir}/plasma/kcms/systemsettings_qwidgets/*.so
%{_kf5_plugindir}/kded/*.so
%{_kf5_plugindir}/krunner/krunner*.so
%{_kf5_qmldir}/org/kde/plasma/activityswitcher
%{_kf5_qmldir}/org/kde/plasma/emoji/
%{_kf5_qmldir}/org/kde/private/desktopcontainment/*
%{_kf5_qmldir}/org/kde/activities/settings/
%{_kf5_datadir}/plasma/*
%ifnarch s390 s390x
%{_bindir}/kcm-touchpad-list-devices
%{_kf5_qtplugindir}/plasma/dataengine/plasma_engine_touchpad.so
%{_kf5_qtplugindir}/plasma/kcminit/kcm_touchpad_init.so
%{_datadir}/dbus-1/interfaces/org.kde.touchpad.xml
%{_kf5_bindir}/kapplymousetheme
%{_kf5_datadir}/kcmmouse/
%{_kf5_qtplugindir}/plasma/kcminit/kcm_mouse_init.so
%endif
%{_datadir}/config.kcfg/*.kcfg
%{_datadir}/kglobalaccel/org.kde.plasma.emojier.desktop
%{_datadir}/qlogging-categories5/*.categories
%{_kf5_datadir}/kconf_update/*
%{_kf5_datadir}/kcmkeys
%{_kf5_datadir}/kpackage/kcms/*
%{_kf5_datadir}/knsrcfiles/
%{_kf5_datadir}/kf5/kactivitymanagerd/workspace/
%{_kf5_datadir}/kf5/kcm_recentFiles/workspace/settings/qml/recentFiles/BlacklistApplicationView.qml
%{_kf5_datadir}/kcmsolidactions/
%{_kf5_datadir}/solid/devices/*.desktop
%{_kf5_datadir}/dbus-1/system.d/*.conf
%{_kf5_datadir}/kservicetypes5/*.desktop
%{_kf5_datadir}/knotifications5/*.notifyrc
%ifnarch s390 s390x
%{_datadir}/icons/hicolor/*/*/*
%endif
%{_kf5_metainfodir}/*.xml
%{_datadir}/applications/*.desktop
%{_datadir}/dbus-1/system-services/*.service
%{_datadir}/polkit-1/actions/org.kde.kcontrol.kcmclock.policy
%{_sysconfdir}/xdg/autostart/*.desktop
%{_kf5_datadir}/accounts/providers/kde/
%{_kf5_datadir}/accounts/services/kde/

%if 0%{?scim}
%files kimpanel-scim
%{_libexecdir}/kimpanel-scim-panel
%endif

%files doc -f %{name}-doc.lang


%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.27.10-1
- initial build
